#ifndef MATRIXH

#define MATRIXH

#include "generic.h"
#include "vector.h"

#define SET_ID_MATRIX(A) \
{ \
   (A)[0][0] = 1.0; \
   (A)[0][1] = 0.0; \
   (A)[0][2] = 0.0; \
   (A)[0][3] = 0.0; \
                     \
   (A)[1][0] = 0.0; \
   (A)[1][1] = 1.0; \
   (A)[1][2] = 0.0; \
   (A)[1][3] = 0.0; \
                     \
   (A)[2][0] = 0.0; \
   (A)[2][1] = 0.0; \
   (A)[2][2] = 1.0; \
   (A)[2][3] = 0.0; \
                     \
   (A)[3][0] = 0.0; \
   (A)[3][1] = 0.0; \
   (A)[3][2] = 0.0; \
   (A)[3][3] = 1.0; \
}

#define COPY_MATRIX(Target,Source) \
{ \
   (Target)[0][0] = (Source)[0][0]; \
   (Target)[0][1] = (Source)[0][1]; \
   (Target)[0][2] = (Source)[0][2]; \
   (Target)[0][3] = (Source)[0][3]; \
 \
   (Target)[1][0] = (Source)[1][0]; \
   (Target)[1][1] = (Source)[1][1]; \
   (Target)[1][2] = (Source)[1][2]; \
   (Target)[1][3] = (Source)[1][3]; \
 \
   (Target)[2][0] = (Source)[2][0]; \
   (Target)[2][1] = (Source)[2][1]; \
   (Target)[2][2] = (Source)[2][2]; \
   (Target)[2][3] = (Source)[2][3]; \
 \
   (Target)[3][0] = (Source)[3][0]; \
   (Target)[3][1] = (Source)[3][1]; \
   (Target)[3][2] = (Source)[3][2]; \
   (Target)[3][3] = (Source)[3][3]; \
}

#define PRINT_MATRIX(Matrix_Name, Matrix) \
{ \
   int i; \
 \
   printf("\n"); \
   for (i = 0; i < 4; i++) { \
      printf("%s[%d] = (%f, %f, %f, %f)\n", (Matrix_Name), i, (Matrix)[i][0], \
             (Matrix)[i][1], (Matrix)[i][2], (Matrix)[i] [3]); \
   } \
   printf("\n"); \
}


#endif

void Matrix_4x4_Multiplication(double **A, double **B, double **C);

